Package io.vertx.rxjava3.uritemplate

## Class UriTemplate

- java.lang.Object
- - io.vertx.rxjava3.uritemplate.UriTemplate

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`

      public class UriTemplate
      extends Object
      implements io.vertx.lang.rx.RxDelegate

  A URI template that follows the rfc6570 level 4.

  A template is immutable and thread safe, it can be safely shared between threads after its creation. If you are sharing a template as a static variables, keep in mind that `of(java.lang.String)` can fail and create a classloading issue.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<UriTemplate>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `UriTemplate​(UriTemplate delegate)` |
    `UriTemplate​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(Object o)` |
    `String` | `expandToString​(Variables variables)` | Expand this template to a string.
    `String` | `expandToString​(Variables variables, ExpandOptions options)` | Expand this template to a string.
    `UriTemplate` | `getDelegate()` |
    `int` | `hashCode()` |
    `static UriTemplate` | `newInstance​(UriTemplate arg)` |
    `static UriTemplate` | `of​(String uri)` | Create a template from a string `uri`.
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<UriTemplate> __TYPE_ARG

  - ### Constructor Detail

    - #### UriTemplate

          public UriTemplate​(UriTemplate delegate)

    - #### UriTemplate

          public UriTemplate​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public UriTemplate getDelegate()

      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`

    - #### of

          public static UriTemplate of​(String uri)

      Create a template from a string `uri`.

      The string `uri` is validated and parsed, invalid inputs are rejected with a `IllegalArgumentException`.

      Parameters:
        `uri` - the template string
      Returns:
        the template

    - #### expandToString

          public String expandToString​(Variables variables)

      Expand this template to a string.
      Parameters:
        `variables` - the variables
      Returns:
        the string expansion of this template with the `variables`

    - #### expandToString

          public String expandToString​(Variables variables,
                                       ExpandOptions options)

      Expand this template to a string.
      Parameters:
        `variables` - the variables
        `options` - the options to control template expansion
      Returns:
        the string expansion of this template with the `variables`

    - #### newInstance

          public static UriTemplate newInstance​(UriTemplate arg)